Texture2D <float4> texwvp:register(t0);
Texture2D texdif0:register(t1);
Texture2D texdif1:register(t2);
Texture2D texdif2:register(t3);
Texture2D texdif3:register(t4);
Texture2D texdif4:register(t5);
Texture2D <float4> texmat:register(t6);
Texture2D texnorm0:register(t7);
Texture2D texnorm1:register(t8);
Texture2D texnorm2:register(t9);
Texture2D texnorm3:register(t10);
Texture2D texnorm4:register(t11);

SamplerState smp:register(s0);

cbuffer WVPdata : register(b0) {
	matrix worldMat;
	matrix wvpMat;
	float3 pointlightpos;
	int paramint0;
	float3 camerapos;
	float paramfloat0;
};
cbuffer Animdata : register(b1) {
	matrix animmat[72];
};
cbuffer cbuff2 : register(b2) {
	float4 wavefacecolor;
	float4 wavespeccolor;
	float4 waveemiccolor;
	float4 woc0;
	float4 woc1;
	float4 woc2;
	float timefloat;
	float pixel1uv;
	float bunbowl0;
	float bunbowl1;
	float bunbowl2;
	float a0;
	float a1;
	float a2;
	float vx;
	float vy;
	float wavepower;
	float ka;
};
cbuffer CBSpriteData : register(b3)
{
	float4 spvtxpos[4];
	float4 spvtxtex[4];
};
cbuffer CBParticleData : register(b4)
{
	float ptldata[512];
};

struct inputBasicType {
	float3 pos:POSITION;
	float2 uv : TEXCOORD;
	float3 norm : NORMAL;
	uint matno : MATNO;
	int joint0 : JOINTNO0;
	float weight0 : WEIGHT0;
	int joint1 : JOINTNO1;
};
struct BasicType {
	float4 svpos:SV_POSITION;//VXep_W
	float2 uv:TEXCOORD;//UVl
	float3 norm : NORMAL;
	float3 posworld : POSWORLD;
	uint matno : MATNO;
};
struct inputBasicTypenm {
	float3 pos:POSITION;
	float2 uv : TEXCOORD;
	float3 norm : NORMAL;
	uint matno : MATNO;
	float3 uvec:UVECTOR;
	float3 vvec:VVECTOR;
};
struct BasicTypenm {
	float4 svpos:SV_POSITION;//VXep_W
	float2 uv:TEXCOORD;//UVl
	float3 norm : NORMAL;
	float3 posworld : POSWORLD;
	uint matno : MATNO;
	float3 uvec:UVECTOR;
	float3 vvec:VVECTOR;
};
struct BasicTypesp {
	float4 svpos:SV_POSITION;//VXep_W
	float2 uv:TEXCOORD;//UVl
};
struct BasicTypeptl {
	float3 pos:POSITION;
	float2 uv : TEXCOORD;
};

float dzdx(float uf1, float vf1)
{
	/*float timefloat = 0.0;
	float4 woc0 = float4(-0.195, -0.195, 0.0, 0.0);
	float4 woc1 = float4(1.195, -0.195, 0.0, 0.0);
	float4 woc2 = float4(0.5, 0.5, 0.0, 0.0);
	float pixel1uv = 0.0039;
	float bunbowl0 = 10.24;
	float bunbowl1 = 17.06;
	float bunbowl2 = 25.6;
	float a0 = 0.5;
	float a1 = 0.4;
	float a2 = 0.7;*/
	float3 uvz = float3(uf1, vf1, 0.0);
	float r0 = length(uvz - woc0.xyz);
	float r1 = length(uvz - woc1.xyz);
	float r2 = length(uvz - woc2.xyz);
	float angletime = timefloat * 62.8;
	return a0 * 6.28 * bunbowl0 * cos(6.28 * r0 * bunbowl0 - angletime) * (uvz.x - woc0.x) / r0
		+ a1 * 6.28 * bunbowl1 * cos(6.28 * r1 * bunbowl1 - angletime) * (uvz.x - woc1.x) / r1
		+ a2 * 6.28 * bunbowl2 * cos(6.28 * r2 * bunbowl1 - angletime) * (uvz.x - woc2.x) / r2;
}
float dzdy(float uf2, float vf2)
{
	/*float timefloat = 0.0;
	float4 woc0 = float4(-0.195, -0.195, 0.0, 0.0);
	float4 woc1 = float4(1.195, -0.195, 0.0, 0.0);
	float4 woc2 = float4(0.5, 0.5, 0.0, 0.0);
	float pixel1uv = 0.0039;
	float bunbowl0 = 10.24;
	float bunbowl1 = 17.06;
	float bunbowl2 = 25.6;
	float a0 = 0.5;
	float a1 = 0.4;
	float a2 = 0.7;*/
	float3 uvz = float3(uf2, vf2, 0.0);
	float r0 = length(uvz - woc0.xyz);
	float r1 = length(uvz - woc1.xyz);
	float r2 = length(uvz - woc2.xyz);
	float angletime = timefloat * 62.8;
	return a0 * 6.28 * bunbowl0 * cos(6.28 * r0 * bunbowl0 - angletime) * (uvz.y - woc0.y) / r0
		+ a1 * 6.28 * bunbowl1 * cos(6.28 * r1 * bunbowl1 - angletime) * (uvz.y - woc1.y) / r1
		+ a2 * 6.28 * bunbowl2 * cos(6.28 * r2 * bunbowl1 - angletime) * (uvz.y - woc2.y) / r2;
}

BasicType BasicVS(inputBasicType input){
	BasicType output;
	float4 pos4n0 = 0;
	float4 pos4p0 = 0;
	float4 pos4n1 = 0;
	float4 pos4p1 = 0;

	pos4n0 = float4(input.norm, 0.0);
	pos4p0 = float4(input.pos, 1.0);

	matrix matbone = input.weight0 * animmat[input.joint0] + (1.0 - input.weight0) * animmat[input.joint1];
	pos4n1 = mul(matbone, pos4n0);
	pos4p1 = mul(matbone, pos4p0);
	
	//pos4n1 = input.weight0 * mul(animmat[input.joint0], pos4n0) + (1.0 - input.weight0) * mul(animmat[input.joint1], pos4n0);
	//pos4p1 = input.weight0 * mul(animmat[input.joint0], pos4p0) + (1.0 - input.weight0) * mul(animmat[input.joint1], pos4p0);
	
	float4 vsveca4 = mul(worldMat, pos4p1);
	output.posworld = vsveca4.xyz;
	output.svpos = mul(wvpMat, pos4p1);
	output.uv = input.uv;
	vsveca4 = mul(worldMat, pos4n1);
	output.norm = normalize(vsveca4.xyz);
	output.matno = input.matno;
	return output;
}
BasicTypenm BasicVSnm(inputBasicTypenm input) {
	BasicTypenm output;

	float4 vsveca4 = mul(worldMat, float4(input.pos, 1.0));
	output.posworld = vsveca4.xyz;
	output.svpos = mul(wvpMat, float4(input.pos, 1.0));
	output.uv = input.uv;
	vsveca4 = mul(worldMat, float4(input.norm, 0.0));
	output.norm = normalize(vsveca4.xyz);
	vsveca4 = mul(worldMat, float4(input.uvec, 0.0));
	output.uvec = normalize(vsveca4.xyz);
	vsveca4 = mul(worldMat, float4(input.vvec, 0.0));
	output.vvec = normalize(vsveca4.xyz);
	output.matno = input.matno;
	return output;
}
BasicTypesp VSsprite(uint vID : SV_VertexID)
{
	BasicTypesp output;

	output.svpos = spvtxpos[vID];
	output.uv = spvtxtex[vID].xy;
	return output;
}
BasicTypeptl VSptl(uint vID : SV_VertexID)
{
	BasicTypeptl output;
	output.pos = float3(ptldata[vID * 5 + 3], ptldata[vID * 5 + 4], ptldata[vID * 5 + 5]);
	output.uv = float2(ptldata[vID * 5 + 6], ptldata[vID * 5 + 7]);
	return output;
}

[maxvertexcount(4)]
void GS_PARTICLE(point BasicTypeptl In[1],
	inout TriangleStream<BasicTypesp> ParticleStream)
{
	float4 gsvec4 = mul(worldMat, float4(In[0].pos, 1.0));
	// _ʂɂ
	float4 posLT = gsvec4 + float4(-ptldata[1]* 0.5, ptldata[2] * 0.5, 0.0, 0.0);
	float4 posLB = gsvec4 + float4(-ptldata[1] * 0.5, -ptldata[2] * 0.5, 0.0, 0.0);
	float4 posRT = gsvec4 + float4(ptldata[1] * 0.5, ptldata[2] * 0.5, 0.0, 0.0);
	float4 posRB = gsvec4 + float4(ptldata[1] * 0.5, -ptldata[2] * 0.5, 0.0, 0.0);

	// ̓_̈ʒu(ˉeWn)vZďo
	BasicTypesp output;
	output.svpos = mul(wvpMat, posLT);
	output.uv = float2(In[0].uv.x, In[0].uv.y);
	ParticleStream.Append(output);

	// E̓_̈ʒu(ˉeWn)vZďo
	output.svpos = mul(wvpMat, posRT);
	output.uv = float2(In[0].uv.x + ptldata[0], In[0].uv.y);
	ParticleStream.Append(output);

	// ̓_̈ʒu(ˉeWn)vZďo
	BasicTypesp output1;
	output1.svpos = mul(wvpMat, posLB);
	output1.uv = float2(In[0].uv.x, In[0].uv.y + ptldata[0]);
	ParticleStream.Append(output1);

	// E̓_̈ʒu(ˉeWn)vZďo
	output.svpos = mul(wvpMat, posRB);
	output.uv = float2(In[0].uv.x + ptldata[0], In[0].uv.y + ptldata[0]);
	ParticleStream.Append(output);

	ParticleStream.RestartStrip();
}

float4 BasicPS(BasicType input) : SV_TARGET{

	float3 light = pointlightpos - input.posworld;
	float3 R = reflect(normalize(-light), input.norm);
	float3 V = normalize(camerapos - input.posworld);
	float4 outputcol = 0;
	float alpha = 0.0;
	
	float3 texCoord3ps = 0;
	
	float4 faceColor4 = 0;
	float4 specularColor4 = 0;
	float4 power4 = 0;
	float4 emissiveColor4 = 0;
	

	if (input.matno < 100) {
		texCoord3ps = float3(input.matno, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 1.0, 0);
		specularColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 2.0, 0);
		power4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 3.0, 0);
		emissiveColor4 = texmat.Load(texCoord3ps);
		switch (input.matno)
		{
		case 0:
			outputcol = texdif0.Sample(smp, input.uv);
			break;
		case 1:
			outputcol = texdif1.Sample(smp, input.uv);
			break;
		case 2:
			outputcol = texdif2.Sample(smp, input.uv);
			break;
		case 3:
			outputcol = texdif3.Sample(smp, input.uv);
			break;
		case 4:
			outputcol = texdif4.Sample(smp, input.uv);
			break;
		}
		if ((outputcol.x == 0.0 && outputcol.y == 0.0 && outputcol.z == 0.0) || (outputcol.w == 0.0)) discard;		
		alpha = outputcol.w * faceColor4.w;
		outputcol = (0.5 * dot(normalize(light), input.norm) + 0.7) * outputcol * faceColor4 + outputcol * emissiveColor4 + (pow(saturate(dot(R, V)), power4.x)) * specularColor4;
		outputcol.w = alpha;
	}
	else {
		texCoord3ps = float3(input.matno - 100, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno - 100, 1.0, 0);
		specularColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno - 100, 2.0, 0);
		power4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno - 100, 3.0, 0);
		emissiveColor4 = texmat.Load(texCoord3ps);
		
		outputcol = (0.5 * dot(normalize(light), input.norm) + 0.7) * faceColor4 + emissiveColor4 + (pow(saturate(dot(R, V)), power4.x)) * specularColor4;
		outputcol.w = faceColor4.w;
	}
	
	return saturate(outputcol);
}
float4 BasicPSnm(BasicTypenm input) : SV_TARGET{
	float3 vdzdx = 0;
	float3 vdzdy = 0;
	float3 light = pointlightpos - input.posworld;
	float3 R = 0;
	float3 V = normalize(camerapos - input.posworld);
	float4 outputcol = 0;
	float4 normcolor = 0;
	float3 normuv = 0;
	float3 normxyz = 0;
	float alpha = 0.0;

	float3 texCoord3ps = 0;

	float4 faceColor4 = 0;
	float4 specularColor4 = 0;
	float4 power4 = 0;
	float4 emissiveColor4 = 0;

	switch (input.matno)
	{
	case 0:
		texCoord3ps = float3(input.matno, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 1.0, 0);
		specularColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 2.0, 0);
		power4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 3.0, 0);
		emissiveColor4 = texmat.Load(texCoord3ps);
		outputcol = texdif0.Sample(smp, input.uv);
		if ((outputcol.x == 0.0 && outputcol.y == 0.0 && outputcol.z == 0.0) || (outputcol.w == 0.0)) discard;
		normcolor = texnorm0.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	case 1:
		texCoord3ps = float3(input.matno, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 1.0, 0);
		specularColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 2.0, 0);
		power4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 3.0, 0);
		emissiveColor4 = texmat.Load(texCoord3ps);
		outputcol = texdif1.Sample(smp, input.uv);
		if ((outputcol.x == 0.0 && outputcol.y == 0.0 && outputcol.z == 0.0) || (outputcol.w == 0.0)) discard;
		normcolor = texnorm1.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	case 2:
		texCoord3ps = float3(input.matno, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 1.0, 0);
		specularColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 2.0, 0);
		power4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 3.0, 0);
		emissiveColor4 = texmat.Load(texCoord3ps);
		outputcol = texdif2.Sample(smp, input.uv);
		if ((outputcol.x == 0.0 && outputcol.y == 0.0 && outputcol.z == 0.0) || (outputcol.w == 0.0)) discard;
		normcolor = texnorm2.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	case 3:
		texCoord3ps = float3(input.matno, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 1.0, 0);
		specularColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 2.0, 0);
		power4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 3.0, 0);
		emissiveColor4 = texmat.Load(texCoord3ps);
		outputcol = texdif3.Sample(smp, input.uv);
		if ((outputcol.x == 0.0 && outputcol.y == 0.0 && outputcol.z == 0.0) || (outputcol.w == 0.0)) discard;
		normcolor = texnorm3.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	case 4:
		texCoord3ps = float3(input.matno, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 1.0, 0);
		specularColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 2.0, 0);
		power4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 3.0, 0);
		emissiveColor4 = texmat.Load(texCoord3ps);
		outputcol = texdif4.Sample(smp, input.uv);
		if ((outputcol.x == 0.0 && outputcol.y == 0.0 && outputcol.z == 0.0) || (outputcol.w == 0.0)) discard;
		normcolor = texnorm4.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	/*case 100:
		vdzdx = float3(1.0, 0.0, dzdx(input.uv.x, input.uv.y));
		vdzdy = float3(0.0, 1.0, dzdy(input.uv.x, input.uv.y));
		normuv = normalize(cross(vdzdx, vdzdy));
		faceColor4 = float4(1.0, 1.0, 1.0, 1.0);
		outputcol = float4(0.1, 0.1, 0.5, 02);
		specularColor4 = float4(0.5, 0.5, 0.5, 1.0);
		power4.x = 0.5;
		emissiveColor4 = float4(0.3, 0.3, 0.3, 1.0);
		break;*/
	default:
		texCoord3ps = float3(input.matno, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 1.0, 0);
		specularColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 2.0, 0);
		power4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 3.0, 0);
		emissiveColor4 = texmat.Load(texCoord3ps);
		outputcol = faceColor4;
		faceColor4 = float4(1.0, 1.0, 1.0, 1.0);
		normuv = float3(0.0, 0.0, 1.0);
		break;
	}
	
	normxyz = normuv.x * input.uvec - normuv.y * input.vvec + normuv.z * input.norm;
	R = reflect(normalize(-light), normxyz);
	alpha = outputcol.w * faceColor4.w;
	outputcol = (0.5 * dot(normalize(light), normxyz) + 0.7) * outputcol * faceColor4 + outputcol * emissiveColor4 + (pow(saturate(dot(R, V)), power4.x)) * specularColor4;
	outputcol.w = alpha;
	

	return saturate(outputcol);
}
float4 BasicPSsp(BasicTypesp input) : SV_TARGET{
	float4 outputcol = 0;
	outputcol = texdif0.Sample(smp, input.uv);
	if ((outputcol.x == 0.0 && outputcol.y == 0.0 && outputcol.z == 0.0) || (outputcol.w == 0.0)) discard;
	return outputcol;
}